## woof-doom 10.5.0+dfsg

=== debian/changelog ===
woof-doom (10.5.0+dfsg-1) unstable; urgency=medium

  * Set Maintainer to Debian Games Team, add myself to Uploaders.
  * New upstream version 10.5.0+dfsg.
  * Remove all patches, applied upstream.
  * Do not hard-code the soundfont anymore, the port offers a choice
    in-game.

 -- Fabian Greffrath <fabian@debian.org>  Wed, 21 Dec 2022 08:31:42 +0100

woof-doom (10.3.0+dfsg-2) unstable; urgency=medium

  * Install all docs into the same directory.
  * Add man/simplecpp to debian/copyright.
  * Run "wrap-and-sort -abst" and complete debian/copyright further.

 -- Fabian Greffrath <fabian@debian.org>  Fri, 21 Oct 2022 19:04:43 +0200

woof-doom (10.3.0+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #1021210)

 -- Fabian Greffrath <fabian@debian.org>  Thu, 06 Oct 2022 09:58:01 +0200
