=== data/CMakeLists.txt ===
if(UNIX AND NOT APPLE)
    install(FILES woof.desktop DESTINATION share/applications)
    install(FILES woof.png DESTINATION share/icons/hicolor/128x128/apps)
    install(FILES woof-setup.desktop DESTINATION share/applications)
    install(FILES woof-setup.png DESTINATION share/icons/hicolor/128x128/apps)
endif()
