=== debian/changelog ===
woof-doom (10.5.1+dfsg-1) unstable; urgency=medium

  * New upstream version 10.5.1+dfsg

 -- Fabian Greffrath <fabian@debian.org>  Wed, 28 Dec 2022 19:36:51 +0100
