=== debian/changelog ===
woof-doom (11.3.0+dfsg-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 14 Aug 2023 07:26:47 -0700

woof-doom (11.3.0+dfsg-1) unstable; urgency=medium

  * New upstream version 11.3.0+dfsg

 -- Fabian Greffrath <fabian@debian.org>  Fri, 14 Jul 2023 15:45:53 +0200

woof-doom (11.2.0+dfsg-2) unstable; urgency=medium

  * Adapt short description to upstream synapsis.
  * Bump versioned Build-Depends according to upstream requirements.

 -- Fabian Greffrath <fabian@debian.org>  Sat, 17 Jun 2023 13:36:13 +0200

woof-doom (11.2.0+dfsg-1) unstable; urgency=medium

  * New upstream version 11.2.0+dfsg.
  * Bump Standards-Version to 4.6.2.
  * Update debian/copyright.
  * Install some more relevant documentation.
  * Replace Build-Depends on libsdl2-mixer-dev with libopenal-dev,
    libsndfile1-dev and libxmp-dev.
  * Add Build-Depends on fluidsynth, because its cmake target requires
    the executable.

 -- Fabian Greffrath <fabian@debian.org>  Fri, 16 Jun 2023 10:58:00 +0200
