=== debian/control ===
--- 
+++ 
@@ -1,36 +1,33 @@
 Source: woof-doom
 Section: games
 Priority: optional
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Fabian Greffrath <fabian@debian.org>
 Rules-Requires-Root: no
-Build-Depends:
- bash-completion,
- cmake,
- debhelper-compat (= 13),
- libfluidsynth-dev,
- libsdl2-dev,
- libsdl2-mixer-dev,
- libsdl2-net-dev,
- python3,
-Standards-Version: 4.6.1
+Build-Depends: bash-completion,
+               cmake,
+               debhelper-compat (= 13),
+               fluidsynth (>= 2.2.0),
+               libfluidsynth-dev (>= 2.2.0),
+               libopenal-dev,
+               libsdl2-dev (>= 2.0.18),
+               libsdl2-net-dev,
+               libsndfile1-dev (>= 1.1.0),
+               libxmp-dev,
+               python3
+Standards-Version: 4.6.2
 Homepage: https://github.com/fabiangreffrath/woof
 Vcs-Git: https://salsa.debian.org/games-team/woof-doom.git
 Vcs-Browser: https://salsa.debian.org/games-team/woof-doom
 
 Package: woof-doom
 Architecture: any
-Depends:
- ${misc:Depends},
- ${shlibs:Depends},
-Recommends:
- freedoom | game-data-packager,
-Provides:
- boom-engine,
- doom-engine,
-Conflicts:
- woof,
-Description: Doom source port MBF targeted at modern systems
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Recommends: freedoom | game-data-packager
+Provides: boom-engine, doom-engine
+Conflicts: woof
+Description: continuation of the Boom/MBF bloodline of Doom source ports
  Woof! is a continuation of Lee Killough's Doom source port MBF
  targeted at modern systems.
  .
