=== debian/rules ===
--- 
+++ 
@@ -16,6 +16,12 @@
 
 execute_after_dh_installdocs:
 	mv debian/woof-doom/usr/share/doc/woof/CMDLINE.txt* \
-	   debian/woof-doom/usr/share/doc/woof/README.md* \
+	   debian/woof-doom/usr/share/doc/woof/*.cfg* \
+	   debian/woof-doom/usr/share/doc/woof/*.lmp* \
+	   debian/woof-doom/usr/share/doc/woof/*.md* \
 	   debian/woof-doom/usr/share/doc/woof-doom
 	rm -rf debian/woof-doom/usr/share/doc/woof
+
+# No dbgsym packages:
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
